﻿
'
' Copyright (c) 2009-2015, MindFusion LLC - Bulgaria.
'
Imports MindFusion.Scheduling.WebForms
Imports MindFusion.Scheduling

Partial Public Class _Default
	Inherits System.Web.UI.Page
	Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
		If Not IsPostBack Then
			' Set the calendar's date
			Dim now As DateTime = DateTime.Today
			_calendar.[Date] = New DateTime(now.Year, now.Month, 1)

			' Select the current date
			_calendar.Selection.Add(DateTime.Today)
			_schedule.TimetableSettings.Dates.Clear()
			_schedule.TimetableSettings.Dates.Add(New TimetableDate(DateTime.Today))

            Dim app As Appointment = New Appointment()
            app.StartTime = DateTime.Today.AddHours(10)
            app.EndTime = DateTime.Today.AddHours(14)
            app.HeaderText = "test item"
            _schedule.Schedule.Items.Add(app)

		End If
		If IsPostBack Then
			'Set the date in the Timetable to match calendar's selection
			Dim [date] As DateTime = _calendar.Selection.Ranges(0)
			_schedule.TimetableSettings.Dates.Clear()
			_schedule.TimetableSettings.Dates.Add(New TimetableDate([date]))
        End If

        _calendar.Schedule = _schedule.Schedule

        'Populate the list box with appointments from the Schedule
        lbItems.Items.Clear()
        For i As Integer = 0 To _schedule.Schedule.Items.Count - 1
            lbItems.Items.Add((_schedule.Schedule.Items(i).StartTime.[Date].ToString("yyyy/MM/dd") & " ") + _schedule.Schedule.Items(i).HeaderText)
        Next
        SortListBox()
	End Sub

	'Sort the listbox alphabetically
	Private Sub SortListBox()
		Dim t As New List(Of ListItem)()
		Dim compare As New Comparison(Of ListItem)(AddressOf CompareListItems)
		For Each lbItem As ListItem In lbItems.Items
			t.Add(lbItem)
		Next

		t.Sort(compare)
		lbItems.Items.Clear()
		lbItems.Items.AddRange(t.ToArray())

	End Sub

	Private Function CompareListItems(ByVal li1 As ListItem, ByVal li2 As ListItem) As Integer
		Return [String].Compare(li1.Text, li2.Text)
	End Function

	'Handles the onVisibleDateChanged event to display selection for the selected month
	Protected Sub _calendar_VisibleDateChanged(ByVal sender As Object, ByVal e As DateChangedEventArgs) Handles _calendar.VisibleDateChanged
		_calendar.Selection.Reset()
		_calendar.Selection.[Set](e.NewDate)
	End Sub

End Class
